Ipelib

Classes | Typedefs | Enumerations | Functions | Variables
ipe Namespace Reference

## Classes
class | A85Source
class | A85Stream
class | AllAttributes
class | Angle
class | Arc
class | Attribute
class | AttributeMap
struct | AttributeMapping
class | Base64Source
class | Base64Stream
class | BBoxPainter
class | Bezier
class | Bitmap
class | BitmapFinder
class | Buffer
class | BufferSource
class | CairoPainter
class | Canvas
class | CanvasBase
class | CanvasObserver
class | Cascade
class | ClosedSpline
class | Color
class | Curve
class | CurveSegment
class | DataSource
class | DeflateStream
class | Document
class | Effect
class | Ellipse
class | Face
class | FileSource
class | FileStream
class | Fixed
class | Fonts
struct | Gradient
class | Group
class | Image
class | ImlParser
class | InflateSource
class | Ipelet
struct | IpeletData
class | IpeletHelper
class | Latex
struct | Layout
class | Lex
class | Line
class | Linear
class | Matrix
class | Object
class | ObjectFactory
class | Page
class | PageSelector
class | Painter
class | PanTool
class | Path
class | PdfArray
class | PdfBool
class | PdfDict
class | PdfFile
class | PdfFileResources
class | PdfName
class | PdfNull
class | PdfNumber
class | PdfObj
class | PdfPainter
class | PdfParser
class | PdfRef
class | PdfResourceBase
class | PdfResources
class | PdfString
class | PdfThumbnail
struct | PdfToken
class | PdfView
class | PdfViewBase
class | PdfWriter
class | Platform
class | PsPainter
class | PsWriter
class | Rect
class | Reference
class | Repository
class | SaveFlag
class | Segment
class | SelectTool
class | Shape
class | Snap
class | Stream
class | String
class | StringStream
class | StyleSheet
class | SubPath
class | Symbol
class | TellStream
class | Text
struct | TextPadding
class | Thumbnail
struct | Tiling
class | Tool
class | TransformTool
class | Vector
class | Visitor
class | XmlAttributes
class | XmlParser

## Typedefs
typedef std::vector< Attribute > | AttributeSeq
using | PdfRenumber = std::unordered_map< int, int >

## Enumerations
enum | Kind { EPen = 0 , ESymbolSize , EArrowSize , EColor , EDashStyle , ETextSize , ETextStretch , ETextStyle , ELabelStyle , EGridSize , EAngleSize , EOpacity , ETiling , ESymbol , EGradient , EEffect }
enum | Property { EPropPen = 0 , EPropSymbolSize , EPropFArrow , EPropRArrow , EPropFArrowSize , EPropRArrowSize , EPropFArrowShape , EPropRArrowShape , EPropStrokeColor , EPropFillColor , EPropMarkShape , EPropPathMode , EPropDashStyle , EPropTextSize , EPropTextStyle , EPropLabelStyle , EPropOpacity , EPropStrokeOpacity , EPropTiling , EPropGradient , EPropHorizontalAlignment , EPropVerticalAlignment , EPropLineJoin , EPropLineCap , EPropFillRule , EPropPinned , EPropTransformations , EPropTransformableText , EPropSplineType , EPropMinipage , EPropWidth , EPropDecoration }
enum | TPathMode { EStrokedOnly , EStrokedAndFilled , EFilledOnly }
enum | THorizontalAlignment { EAlignLeft , EAlignRight , EAlignHCenter }
enum | TVerticalAlignment { EAlignBottom , EAlignBaseline , EAlignTop , EAlignVCenter }
enum | TSplineType { EBSpline , ECardinalSpline , ESpiroSpline }
enum | TLineJoin { EDefaultJoin , EMiterJoin , ERoundJoin , EBevelJoin }
enum | TLineCap { EDefaultCap , EButtCap , ERoundCap , ESquareCap }
enum | TFillRule { EDefaultRule , EWindRule , EEvenOddRule }
enum | TPinned { ENoPin = 0x00 , EHorizontalPin = 0x01 , EVerticalPin = 0x02 , EFixedPin = 0x03 }
enum | TTransformations { ETransformationsTranslations , ETransformationsRigidMotions , ETransformationsAffine }
enum | TSelect { ENotSelected = 0 , EPrimarySelected , ESecondarySelected }
enum class | LatexType { Default , Pdftex , Xetex , Luatex }
enum class | FileFormat { Xml , Pdf , Unknown }
enum class | FontType { Type1 , Truetype , CIDType0 , CIDType2 , Type3 , Unsupported }

## Functions
template<typename T >
int | size (const std::vector< T > &v)
void | ipeDebugBuffer (Buffer data, int maxsize)
template<class T >
T | max (const T &lhs, const T &rhs)
template<class T >
T | min (const T &lhs, const T &rhs)
double | abs (double val)
QPointF | QPt (const Vector &v)
String | IpeQ (const QString &str)
QString | QIpe (const String &str)
QColor | QIpe (Color color)
Color | IpeQ (QColor color)

## Variables
const char *const | kind_names []
const char *const | property_names []
constexpr double | IPE_PI = 3.14159265358979323846
constexpr char | IPESEP = '/'
const int | IPELIB_VERSION = 70224
const int | OLDEST_FILE_FORMAT = 70000
const int | FILE_FORMAT = 70218

## Typedef Documentation

## ◆ AttributeSeq

typedef std::vector<Attribute> ipe::AttributeSeq

## ◆ PdfRenumber

using ipe::PdfRenumber = typedef std::unordered_map<int,int>

## Enumeration Type Documentation

## ◆ LatexType

enum class ipe::LatexType
| strong

Enumerator
Default |
Pdftex |
Xetex |
Luatex |

## ◆ FileFormat

enum class ipe::FileFormat
| strong

There are several Ipe document formats.

Enumerator
Xml | Save as XML.
Pdf | Save as PDF.
Unknown | Unknown file format.

## ◆ FontType

enum class ipe::FontType
| strong

Enumerator
Type1 |
Truetype |
CIDType0 |
CIDType2 |
Type3 |
Unsupported |

## Function Documentation

## ◆ size()

template<typename T >

int ipe::size | ( | const std::vector< T > & | v | ) |
| inline

References size().

Referenced by ipe::Curve::appendSpiroSpline(), ipe::Curve::appendSpiroSplinePrecomputed(), ipe::PdfWriter::createBookmarks(), ipe::DeflateStream::deflate(), ipe::Path::drawArrow(), ipe::String::empty(), ipe::String::find(), ipe::String::find(), ipe::PdfFile::findPageFromPageObjectNumber(), ipe::Reference::getAttribute(), ipe::Text::getAttribute(), ipe::String::getLine(), ipe::Face::glyphIndex(), ipe::String::hasPrefix(), ipe::Arc::intersect(), ipe::Snap::intersectionSnap(), ipe::Page::layerMatrices(), ipe::String::operator<(), ipe::String::operator==(), ipe::String::operator==(), ipe::PdfFile::parse(), ipe::ImlParser::parseStyle(), ipe::PdfWriter::PdfWriter(), ipe::Stream::putRaw(), ipe::StringStream::putRaw(), ipe::FileStream::putRaw(), ipe::String::rfind(), ipe::String::right(), ipe::ClosedSpline::save(), ipe::AttributeMap::saveAsXml(), ipe::StyleSheet::saveAsXml(), ipe::Path::setArrow(), ipe::Path::setRarrow(), size(), and ipe::Face::width().

## ◆ ipeDebugBuffer()

void ipe::ipeDebugBuffer | ( | Buffer | data,
|  | int | maxsize
| ) |  |
| extern

## ◆ QPt()

QPointF ipe::QPt | ( | const Vector & | v | ) |
| inline

References ipe::Vector::x, and ipe::Vector::y.

## ◆ IpeQ() [1/2]

String ipe::IpeQ | ( | const QString & | str | ) |
| inline

Referenced by ipe::Canvas::keyPressEvent().

## ◆ QIpe() [1/2]

QString ipe::QIpe | ( | const String & | str | ) |
| inline

References ipe::String::z().

## ◆ QIpe() [2/2]

QColor ipe::QIpe | ( | Color | color | ) |
| inline

References ipe::Color::iBlue, ipe::Color::iGreen, ipe::Color::iRed, and ipe::Fixed::toDouble().

## ◆ IpeQ() [2/2]

Color ipe::IpeQ | ( | QColor | color | ) |
| inline

## Variable Documentation

## ◆ IPE_PI

constexpr double ipe::IPE_PI = 3.14159265358979323846
| constexpr

Referenced by ipe::CanvasBase::CanvasBase(), and ipe::Path::draw().

## ◆ IPESEP

constexpr char ipe::IPESEP = '/'
| constexpr

Referenced by ipe::Platform::runLatex().